      SUBROUTINE ACORD(NSUB)
C     SUBROUTINE ACORD(STINF,NSUB)
C.....ACORD - AUTOMATIC CONTOURING OF RAW DATA - D.F.WATSON
C.....READ DATA POINTS AND FORM ALL 3-TUPLES S.T. NO OTHER POINT
C     LIES WITHIN THAT 3-TUPLES CIRCUMCIRCLE
C.....PNT HOLDS THE DATA POINTS AND TETR CARRIES THE CIRCUMCIRCLE
C     CENTRE AND RADIUS SQUARED FOR EACH 3-TUPLE
C.....ITETR HOLDS THE DATA POINT INDICES IN INPUT ORDER OF EACH 3-TUPLE
C.....ISTACK IS A LAST-IN-FIRST-OUT STACK OF INDICES OF VACANT 3-TUPLES
C.....KTETR IS A TEMPORARY LIST OF EDGES OF DELETED 3-TUPLES
C.....ID IS POINTER TO ISTACK AND JT IS POINTER TO TETR AND ITETR
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /INDATA/ SUB(2900,3)
      COMMON /TRIA/ PNT(3000,3),ITETR(6000,3),TETR(6000,3),DATAX,ISP,
     1              XMIN,YMIN
      DIMENSION XPNT(3,3), DET(2,3), XP(3),YP(3),ZP(3)
      INTEGER  ISTACK(6000), KTETR(100,2), ITEMP(3,2)
17    FORMAT('+ Triangulating point ',i4,' of ',i4,'                  ')
18    FORMAT(' ',A1,'[5m   WORKING on triangulation of elevations   ',
     + '             ')
19    FORMAT('+',A1,'[0m                                            ',
     + '             ')
      WRITE(*,18) CHAR(27)
      ISP=1
      ID=2
      XMIN=99999.9
      YMIN=99999.9
      XMAX=-99999.9
      YMAX=-99999.9
      ITEMP(1,1)=1
      ITEMP(2,1)=1
      ITEMP(3,1)=2
      ITEMP(1,2)=2
      ITEMP(2,2)=3
      ITEMP(3,2)=3
      DO 2 I=1,6000
       IF(I.GT.3000) GOTO 1
       PNT(I,1)=0.0
       PNT(I,2)=0.0
       PNT(I,3)=0.0
1      TETR(I,1)=0.0
       TETR(I,2)=0.0
       TETR(I,3)=0.0
       ITETR(I,1)=0
       ITETR(I,2)=0
       ITETR(I,3)=0
2      ISTACK(I)=0
      DO 3 I=1,100
       KTETR(I,1)=0
3      KTETR(I,2)=0
      DO 4 I = 1,3
4      ITETR(1,I) = I
      ISTACK(1)=0
      DO 5 I = 2,6000
5      ISTACK(I) = I
C.....                                     SET OUTPUT SIZE FACTOR
      SIZE = 20.0
      N=3
      DO 12 I=1,NSUB
       N=N+1
       PNT(N,1)=SUB(I,1)
       PNT(N,2)=SUB(I,2)
       PNT(N,3)=SUB(I,3)
       IF(PNT(N,1) .GT. XMAX) XMAX = PNT(N,1)
       IF(PNT(N,1) .LT. XMIN) XMIN = PNT(N,1)
       IF(PNT(N,2) .GT. YMAX) YMAX = PNT(N,2)
       IF(PNT(N,2) .LT. YMIN) YMIN = PNT(N,2)
12     CONTINUE
      DATAX = XMAX - XMIN
      Y = YMAX - YMIN
      IF(Y .GT. DATAX) DATAX = Y
      PNT(1,1) = XMIN - 1.0*DATAX
      PNT(1,2) = YMIN - 1.0*DATAX
      PNT(2,1) = PNT(1,1) + 6.0*DATAX
      PNT(2,2) = PNT(1,2)
      PNT(3,1) = PNT(1,1)
      PNT(3,2) = PNT(1,2) + 6.0*DATAX
      TETR(1,1) = PNT(1,1) + 3.0*DATAX
      TETR(1,2) = PNT(1,2) + 3.0*DATAX
      TETR(1,3) = 2.0*(3.0*DATAX)**2
      DO 50 NUC = 4,N
        IF(MOD(NUC,50).EQ.0) PRINT 17,NUC,N
        KM = 0
C.......LOOP THRU THE ESTABLISHED 3-TUPLES
        DO 30 JT = 1,ISP
C.........TEST IF NEW DATA POINT IS WITHIN THE JT CIRCUMCIRCLE
          DSQ = TETR(JT,3) - (PNT(NUC,1) - TETR(JT,1))**2
          IF(DSQ .LT. 0.0) GO TO 30
          DSQ = DSQ - (PNT(NUC,2) - TETR(JT,2))**2
          IF(DSQ .LT. 0.0) GO TO 30
C.........DELETE THIS 3-TUPLE BUT SAVE ITS EDGES
          ID = ID - 1
          ISTACK(ID) = JT
C.........ADD EDGES TO KTETR BUT DELETE IF ALREADY LISTED
          DO 28 I = 1,3
            L1 = ITEMP(I,1)
            L2 = ITEMP(I,2)
            IF(KM .LE. 0) GO TO 26
            KMT = KM
            DO 24 J = 1,KMT
              IF(ITETR(JT,L1) .NE. KTETR(J,1)) GO TO 24
              IF(ITETR(JT,L2) .NE. KTETR(J,2)) GO TO 24
              KM = KM - 1
              IF(J .GT. KM) GO TO 28
              DO 20 K = J,KM
                K1 = K + 1
                DO 20 L = 1,2
   20             KTETR(K,L) = KTETR(K1,L)
                GO TO 28
   24         CONTINUE
   26       KM = KM + 1
            KTETR(KM,1) = ITETR(JT,L1)
            KTETR(KM,2) = ITETR(JT,L2)
   28       CONTINUE
   30     CONTINUE
C.......FORM NEW 3-TUPLES
        DO 48 I = 1,KM
          KT = ISTACK(ID)
          ID = ID + 1
C.........CALCULATE THE CIRCUMCIRCLE CENTER AND RADIUS
C         SQUARED OF POINTS KTETR(I,*) AND PLACE IN TETR(KT,*)
          DO 44 JZ = 1,2
            I2 = KTETR(I,JZ)
            DET(JZ,1) = PNT(I2,1) - PNT(NUC,1)
            DET(JZ,2) = PNT(I2,2) - PNT(NUC,2)
   44       DET(JZ,3) = DET(JZ,1) * (PNT(I2,1) + PNT(NUC,1))/2.0
     +                + DET(JZ,2) * (PNT(I2,2) + PNT(NUC,2))/2.0
          DD = DET(1,1) * DET(2,2) - DET(1,2) * DET(2,1)
          IF(DD.EQ.0.0) DD = 1.0E-15
          TETR(KT,1) = (DET(1,3) * DET(2,2) - DET(2,3) * DET(1,2))/DD
          TETR(KT,2) = (DET(1,1) * DET(2,3) - DET(2,1) * DET(1,3))/DD
          TETR(KT,3) = (PNT(NUC,1) - TETR(KT,1))**2
     +               + (PNT(NUC,2) - TETR(KT,2))**2
          ITETR(KT,1) = KTETR(I,1)
          ITETR(KT,2) = KTETR(I,2)
   48     ITETR(KT,3) = NUC
   50   ISP = ISP + 2
      WRITE(*,19) CHAR(27)
      RETURN
      END

